﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        static int n;
        static int vsali = 0;
        static Dictionary<int, int> ostalos = new Dictionary<int, int>();
        static void Main(string[] args)
        {
            n = int.Parse(Console.ReadLine().Trim());
            for (int i = 0; i < n; i++)
            {
                ostalos.Add(i, int.Parse(Console.ReadLine().Trim()) - 1);
            }
            if (n==1) {
                ret(1);
            }
            easy();
            clear();
            while (ostalos.Count > 0)
            {
                cycle();
            }
            ret(vsali);
        }
        static bool easy() {
            if (ostalos[0]!=-2) {
                return false;
            }
            for (int i=1;i<n;i++) {
                if (ostalos[i]!=i-1) {
                    return false;
                }
            }
            ret((n / 2) + (n % 2));
            return true;
        }
        static void cycle()
        {
            int start = -1;
            foreach (KeyValuePair<int, int> kv in ostalos)
            {
                start = kv.Key;
                break;
            }
            int current = ostalos[start];
            List<int> todel = new List<int>();
            todel.Add(start);
            while (current != start)
            {
                todel.Add(current);
                current = ostalos[current];
            }
            int add = 0;
            foreach (int i in todel)
            {
                if (ostalos.ContainsKey(i)) { ostalos.Remove(i); add++; }
            }
            vsali += add / 2;
            //vsali += add % 2;
            notex();
        }
        static void clear()
        {
            int[] bads = new int[n];
            for (int i = 0; i < n; i++)
            {
                bads[i] = 0;
            }
            foreach (KeyValuePair<int, int> kv in ostalos)
            {
                if (kv.Value != -2)
                {
                    bads[kv.Value]++;
                }
            }
            bool was = false;
            List<int> todel = new List<int>();
            foreach (KeyValuePair<int, int> kv in ostalos)
            {
                if (bads[kv.Key] == 0)
                {
                    todel.Add(kv.Key);
                    todel.Add(kv.Value);
                    /*if (kv.Value != -2)
                    {
                        int nak = ostalos[kv.Value];
                        if (nak != -2) {
                            bads[nak]--;
                        }
                    }*/
                    was = true;
                    vsali++;
                }
            }
            if (was)
            {
                foreach (int i in todel)
                {
                    if (ostalos.ContainsKey(i)) { ostalos.Remove(i); }
                }
                notex();
                clear();
            }
        }
        static void notex()
        {
            Dictionary<int, int> c = new Dictionary<int, int>();
            foreach (KeyValuePair<int, int> kv in ostalos)
            {
                if (!ostalos.ContainsKey(kv.Value))
                {
                    c.Add(kv.Key, -2);
                }
            }
            foreach (KeyValuePair<int, int> kv in c)
            {
                ostalos[kv.Key] = kv.Value;
            }
        }
        static void ret(long res)
        {
            Console.Write(res);
            Console.Read();
            Environment.Exit(0);
        }
        public class Person
        {
            public int i;
            public int hate;
            public Person(int a, int b)
            {
                i = a;
                hate = b;
            }
        }
    }
}
